//AlphaKanalWahl_202d.js
// 25.01.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Einen Alpha-Kanal zuweisen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.", "Achtung", true);
	exit();
}

// die Auswahl speichern ...
var curSel = app.selection;
var nItems = curSel.length;
// ... und prfen
if (nItems == 0) {
	alert ("Es ist nichts ausgewhlt.", "Stop", true);
	exit();
}
// testen, ob ein Bildrahmen oder ein Bild ausgewhlt ist 
// und den Pfad zur Bilddatei speichern
var objType = curSel[0].constructor.name;
if (objType == "Rectangle" || objType == "Polygon" || objType == "Oval") {
	if (curSel[0].graphics.length == 0) {
		alert ("Der Bildrahmen ist leer.", "Stop", true);
		exit();
	}
	else {
		var curObj = curSel[0].images[0];
	}
}
else if (objType == "Image") {
	var curObj = curSel[0];
}
else {
	alert ("Bitte ein Bild auswhlen.", "Achtung", true);
	exit();
}
try {
	var curLink = curObj.itemLink;
	var curPath = curLink.filePath;
}
catch (e) {
	alert ("Keine Grafik, bitte.", "Achtung", true);
	exit();
}

// den Status der Verknpfung feststellen ...
var curStatus = curLink.status*1;
// ... und prfen
if (curStatus == 1819109747) {
	alert ("Die Bilddatei existiert nicht.", "Stop", true);
	exit();
}
else if (curStatus == 1819242340) {
	alert ("Zuerst die Verknpfung aktualisieren.", "Achtung", true);
	exit();
}
// die Alpha-Kanle auflisten
var alphaNames = curObj.clippingPath.alphaChannelPathNames;
// die Anzahl Alpha-Kanle prfen
if (alphaNames.length == 0) {
	alert ("Das Bild enthlt keinen Alpha-Kanal.", "Stop", true);
	exit();
}
else {
	var dialogNames = alphaNames.concat(["keinen"]);
}
// eventuell im Speicher vorhandene Dialoge entfernen
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}
// den Dialog vorbereiten ...
var aDialog = app.dialogs.add({name:"Den Alpha-Kanal whlen:"});
with (aDialog) {
	with (dialogColumns.add()) {
		var alphaDrop = dropdowns.add({stringList:dialogNames, selectedIndex:0});
	}
}
// ... und anzeigen
if (aDialog.show() == true) {
	// den gewhlten Artikel feststellen
	var curAlpha = dialogNames[alphaDrop.selectedIndex];
	// den Dialog aus dem Speicher entfernen
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}
// die Vorgaben einstellen
app.imageIOPreferences.alphaChannelName = curAlpha;
// das Bild erneut importieren
curSel[0].place(File(curPath));